<script>
  import { max, min } from "d3-array";

  // Properties to export
  export let data = [];
  export let sliderValue = 0;
  export let continent = "all continents";


  const minIndex = min(data, (d) => d.year) - 1800;
  const maxIndex = max(data, (d) => d.year) - 1800;

  //  ANIMATION 
  let play = "Play";
  let counterInterval = null;

  
  const click_play = () => {
    play = play == "Play" ? "Pause" : "Play"; // Change text
    if (counterInterval === null) {
      counterInterval = setInterval(incYear, 20);
    } else {
      clearInterval(counterInterval);
      counterInterval = null;
    }
  };


  const incYear = () => {
    if (sliderValue == maxIndex) {
      sliderValue = 0;
      clearInterval(counterInterval);
      play = "Play";
    } else {
      sliderValue += 1;
    }
  };

  
  const reset = () => {
    continent = "all continents";
    play = "Play";
    sliderValue = 0;
    if (counterInterval) {
      clearInterval(counterInterval);
      counterInterval = null;
    }
  };

  // PULL DOWN 
  const continents = ["europe", "asia", "americas", "africa"];
  let display_pull_down = "none";

  
  const clickPullDown = () => {
    display_pull_down = display_pull_down == "none" ? "block" : "none";
  };

 
  const changeContinent = (newContinent) => {
    continent = newContinent;
  };
</script>

<div class="row justify-content-center">
  <input type="range" min={minIndex} max={maxIndex} bind:value={sliderValue} />
  <p align="center">Year {sliderValue + 1800}</p>
</div>

<div class="container" style="padding-bottom: 20px">
  <div class="row">
    <div class="col-sm">
      <button
        type="button"
        class="btn btn-primary"
        on:click={() => click_play()}>{play}</button
      >
    </div>

    <div class="col-sm">
      <button type="button" class="btn btn-primary" on:click={() => reset()}
        >Reset</button
      >
    </div>

    <div class="dropdown col-sm">
      <button
        class="btn btn-primary dropdown-toggle"
        type="button"
        id="dropdownMenu2"
        data-toggle="dropdown"
        aria-haspopup="true"
        aria-expanded="true"
        on:click={() => clickPullDown()}
      >
        {continent}
      </button>
      <div class="dropdown-menu" style="display:{display_pull_down}">
        <button
          class="dropdown-item"
          type="button"
          on:click={() => changeContinent("all continents")}
          >all continents</button
        >
        <button
          class="dropdown-item"
          type="button"
          on:click={() => changeContinent(continents[0])}
          >{continents[0]}</button
        >
        <button
          class="dropdown-item"
          type="button"
          on:click={() => changeContinent(continents[1])}
          >{continents[1]}</button
        >
        <button
          class="dropdown-item"
          type="button"
          on:click={() => changeContinent(continents[2])}
          >{continents[2]}</button
        >
        <button
          class="dropdown-item"
          type="button"
          on:click={() => changeContinent(continents[3])}
          >{continents[3]}</button
        >
      </div>
    </div>
  </div>
</div>

<style>
  .btn {
    width: 200px;
  }
</style>
